unit Parser;

interface

uses
  Globals,Scaner;

  procedure Assignment;

implementation

procedure Assignment;
var
  temp: TTokenType;

  function Stack(n: byte):PType;
  var
    i: integer;
    r: PType;
  begin
    case n of
      0: if Length(StackArr)>0 then SetLength(StackArr,0);
      1:
        begin
          i := Length(StackArr);
          SetLength(StackArr,i+1);
          StackArr[i] := P;
          result := Data;
        end;
      2:
        begin
          i := Length(StackArr)-1;
          r := StackArr[i];
          SetLength(StackArr,i);
          result := r;
        end;
    end;
  end;

  procedure Expr; Forward

  procedure Factor;
  begin

    if Token = tkOpenParen then
    begin
      NextToken;
      Expr;
      if Token <> tkCloseParen then EmitLn('  ');
    end
    else
      if Token in [tkNumber,tkFloat,tkString,tkIdent] then
      begin
        Stack(1);
        P := Data;
      end;
      case Token of
        tkNumber    : WriteLn(CharToOem('  -> '),Data.int,' ',TokenTypeText[Token]);
        tkFloat     : WriteLn(CharToOem('  -> '),Data.float,' ',TokenTypeText[Token]);
        tkString    : WriteLn(CharToOem('  -> '),Data.str,' ',TokenTypeText[Token]);
        tkIdent     : WriteLn(CharToOem('  -> '),TokenTypeText[Token]);
        tkCloseParen: ;
      else
        EmitLn('');
      end;
    NextToken;

  end;

  procedure Term;
  var
    D : PType;
  begin
    Factor;
    while True do begin
      case Token of
        tkMultiply:
                    begin
                      NextToken;
                      temp:= Token;
                      Factor;
                      if not (temp in [tkNumber,tkFloat,tkIdent]) then EmitLn(' *');
                      //   
                      D := Stack(2);
                      if P.tok<>tkIdent then
                      begin
                        if D.tok = P.tok then
                          case P.tok of
                            tkNumber:   P.int    := D.int   * P.int;
                            tkFloat :   P.float  := D.float * P.float;
                          end
                        else
                          case P.tok of
                            tkNumber:
                                      begin
                                        P.float  := D.float * P.int;
                                        P.tok    := tkFloat;
                                      end;
                            tkFloat :
                                      begin
                                        P.float  := D.int   * P.float;
                                        P.tok    := tkFloat;
                                      end;
                          end;
                        case P.tok of
                          tkNumber: WriteLn(P.int);
                          tkFloat : WriteLn(P.float);
                        end;
                      end
                      else
                        EmitLn(''); //  
                    end;

        tkDivide:
                    begin
                      NextToken;
                      temp := Token;
                      Factor;
                      if not (temp in [tkNumber,tkFloat,tkIdent]) then EmitLn(' /');
                      //if ((P.int=0) OR (P.float=0)) then EmitLn('  0');
                      //   
                      D := Stack(2);
                      if P.tok<>tkIdent then
                      begin
                        if D.tok = P.tok then
                          case P.tok of
                            tkNumber:
                                      begin
                                        P.float  := D.int / P.int;
                                        P.tok    := tkFloat;
                                      end;
                            tkFloat :   P.float  := D.float / P.float;
                          end
                        else
                          case P.tok of
                            tkNumber:
                                      begin
                                        P.float  := D.float / P.int;
                                        P.tok    := tkFloat;
                                      end;
                            tkFloat :
                                      begin
                                        P.float  := D.int   / P.float;
                                        P.tok    := tkFloat;
                                      end;
                          end;
                        case P.tok of
                          tkNumber: WriteLn(P.int);
                          tkFloat : WriteLn(P.float);
                        end;
                      end
                      else
                        EmitLn('');
                    end;
        tkDiv:
                    begin
                      NextToken;
                      temp := Token;
                      Factor;
                      if not (temp in [tkNumber,tkIdent]) then EmitLn(' div');
                      //   
                      D := Stack(2);
                      if P.tok<>tkIdent then
                      begin
                        if D.tok = P.tok then
                          P.int  := D.int div P.int
                        else
                          EmitLn('  ');
                        case P.tok of
                          tkNumber: WriteLn(P.int);
                          tkFloat : WriteLn(P.float);
                        end;
                      end
                      else
                        EmitLn('  '); //  
                    end;
        tkMod:
                    begin
                      NextToken;
                      temp := Token;
                      Factor;
                      if not (temp in [tkNumber,tkIdent]) then EmitLn('');
                      //   
                      D := Stack(2);
                      EmitLn('  ');//  
                    end;
      else
        Break;
      end;
    end;
  end;

  procedure Expr;
  var
    D : PType;
  begin

    if not (Token in [tkNumber,tkFloat,tkString,tkIdent,tkOpenParen]) then
      Stack(0)
    else
      Term;

    while True do
    begin
      case Token of

        tkPlus:
                begin
                  NextToken;
                  temp := Token;
                  Term;
                  if not (temp in [tkNumber,tkFloat,tkString,tkIdent]) then EmitLn(' +');
                  //   
                  D := Stack(2);
                  if P.tok<>tkIdent then
                  begin
                    if D.tok = P.tok then
                      case P.tok of
                        tkNumber:   Inc(P.int,D.int);
                        tkFloat :   P.float  := D.float + P.float;
                        tkString:   P.str    := D.str   + P.str;
                      end
                    else
                      case P.tok of
                        tkNumber:
                                  begin
                                    P.float  := D.float + P.int;
                                    P.tok    := tkFloat;
                                  end;
                        tkFloat :
                                  begin
                                    P.float  := D.int   + P.float;
                                    P.tok    := tkFloat;
                                  end;
                        tkString:   EmitLn(' ');
                      end;

                      case P.tok of
                        tkNumber: WriteLn(P.int);
                        tkFloat : WriteLn(P.float);
                        tkString: WriteLn(P.str);
                      end;
                    end
                    else
                      EmitLn('');//  
                  end;

        tkMinus:
                  begin
                    NextToken;
                    temp := Token;
                    Term;
                    if not (temp in [tkNumber,tkFloat,tkIdent]) then EmitLn(' -');
                    //   
                    D := Stack(2);
                    if P.tok<>tkIdent then
                    begin
                      if D.tok = P.tok then
                        case P.tok of
                          tkNumber:   P.int    := D.int   - P.int;
                          tkFloat :   P.float  := D.float - P.float;
                        end
                      else
                        case P.tok of
                          tkNumber:
                                    begin
                                      P.float  := D.float - P.int;
                                      P.tok    := tkFloat;
                                    end;
                          tkFloat :
                                    begin
                                      P.float  := D.int   - P.float;
                                      P.tok    := tkFloat;
                                    end;
                        end;
                      case P.tok of
                        tkNumber: WriteLn(P.int);
                        tkFloat : WriteLn(P.float);
                      end;
                    end
                    else
                      EmitLn(''); //  
                  end;

      else
        Break;
      end;
    end;
  end;

begin
  Expr;
end;

end.
